import { DayGridRange, EventRangeProps, DateComponent, Hit, DateMarker, DateProfile, DateRange, DateFormatter, ViewContext } from '@fullcalendar/core/internal';
import { VResourceJoiner, AbstractResourceDayTableModel, ResourceViewProps, Resource } from '@fullcalendar/resource/internal';
import { createElement } from '@fullcalendar/core/preact';
import { RowConfig } from '@fullcalendar/daygrid/internal';

declare class ResourceDayTableJoiner extends VResourceJoiner<DayGridRange> {
    transformSeg(seg: DayGridRange & EventRangeProps, resourceDayTableModel: AbstractResourceDayTableModel, resourceI: number): (DayGridRange & EventRangeProps)[];
}

declare class ResourceDayGridView extends DateComponent<ResourceViewProps> {
    private flattenResources;
    private buildResourceDayTableModel;
    private createDayHeaderFormatter;
    private buildResourceRowConfigs;
    private resourceDayTableModel;
    private splitter;
    private slicers;
    private joiner;
    render(): createElement.JSX.Element;
    isHitComboAllowed: (hit0: Hit, hit1: Hit) => boolean;
}

declare function buildResourceRowConfigs(resources: Resource[], datesAboveResources: boolean, dates: DateMarker[], datesRepDistinctDays: boolean, dateProfile: DateProfile, todayRange: DateRange, dayHeaderFormat: DateFormatter, // TODO: rename to dateHeaderFormat?
context: ViewContext): RowConfig<{
    text: string;
    isDisabled: boolean;
}>[];

export { ResourceDayGridView, ResourceDayTableJoiner, buildResourceRowConfigs };
